#include <sys/socket.h>    // socketΤɬפʥإåե
#include <netdb.h>         // getaddrinfo()Τɬפʥإåե
#include <sys/select.h>    // selectΤɬפʥإåե
#include <unistd.h>        // readwriteΤɬפʥإåե
#include <stdio.h>         // perror()Τɬפʥإåե
#include <string.h>        // memset()Τɬפʥإåե

int
main(int argc, char **argv)
{
  int sock_fd;             // åȤΥե뵭һ
  struct addrinfo hints, *res;   // getaddrinfo()ǻѤaddrinfo¤
  int err;                 // getaddrinfo()Υ顼
  fd_set readfds;          // ɤ߽Фƻѥե뵭һҤν
  ssize_t n;               // ɤ߹ߥХȿѿ
  char buf[4096];          // ǡѥХåե

  if (argc != 3) {         // ޥɰθĿʤ
    fprintf(stderr, "Usage: %s hostname port\n", argv[0]);
    return 1;              // Usage:ɽơ1ǰ۾ｪλ
  }

  memset(&hints, 0, sizeof hints);  // addrinfo¤Τhints0ǥꥢ
  hints.ai_family = AF_UNSPEC;      // IPv4ޤIPv6б
  hints.ai_socktype = SOCK_STREAM;  // TCP
                           // ޥɰΥۥ̾ȥӥ̾
                           // IPɥ쥹ȥݡֹѴ
  if ((err = getaddrinfo(argv[1], argv[2], &hints, &res)) != 0) {
    fprintf(stderr, "%s %s: %s\n", argv[1], argv[2], gai_strerror(err));
    return 1;              // ѴǤʤäϥ顼ɽư۾ｪλ
  }
                           // IPv4ޤIPv6TCPΥåȤ
  if ((sock_fd = socket(res->ai_family, res->ai_socktype, 0)) < 0) {
    perror("socket");      // 顼ξϥåɽ
    return 1;              // 1ǰ۾ｪλ
  }
                           // IPɥ쥹λݡֹ³
  if (connect(sock_fd, res->ai_addr, res->ai_addrlen) < 0) {
    perror("connect");     // 顼ξϥåɽ
    return 1;              // 1ǰ۾ｪλ
  }

  for (;;) {               // ̿ΤΥ롼
    FD_ZERO(&readfds);          // ե뵭һҽ
    FD_SET(0, &readfds);        // ɸϤΥե뵭һҤ򥻥å
    FD_SET(sock_fd, &readfds);  // åȤΥե뵭һҤ򥻥å

                           // ɸϤȥåȤؤΥǡƱ˴ƻ
    if (select(sock_fd + 1, &readfds, NULL, NULL, NULL) < 0) {
      perror("select");    // 顼ξϥåɽ
      return 1;            // 1ǰ۾ｪλ
    }

    if (FD_ISSET(0, &readfds)) {  // ɸϤϤä
      if ((n = read(0, buf, sizeof buf)) < 0) {  // ɸϤɤ߹
        perror("read");    // 顼ξϥåɽ
        return 1;          // 1ǰ۾ｪλ
      }
      if (n == 0) {        // ɸϤEOFˤʤä
        break;             // forʸΥ롼פλ
      }
      write(sock_fd, buf, n);  // ɤ߹ǡ򥽥åȤ
    }

    if (FD_ISSET(sock_fd, &readfds)) {  // åȤ
      if ((n = read(sock_fd, buf, sizeof buf)) < 0) {  // åȤɤ߹
        perror("read");    // 顼ξϥåɽ
        return 1;          // 1ǰ۾ｪλ
      }
      if (n == 0) {        // åȤEOFˤʤä
        break;             // forʸΥ롼פλ
      }
      write(1, buf, n);    // ɤ߹ǡɸϤ˽
    }
  }

  if (shutdown(sock_fd, SHUT_RDWR) < 0) {  // åȤ򥷥åȥ
    perror("shutdown");    // 顼ξϥåɽ
    return 1;              // 1ǰ۾ｪλ
  }
  return 0;                // 0ｪλ
}
