#include <sys/wait.h>      // waitidΤɬפʥإåե

#ifdef __FreeBSD__
# include <signal.h>       // FreeBSDǤsignal.hɬ
#endif

#include <unistd.h>        // forkΤɬפʥإåե
#include <stdio.h>         // perror()Τɬפʥإåե

int
main()
{
  pid_t pid;                          // ҥץΥץID
  siginfo_t info;                     // ҥץξ빽¤

  if ((pid = fork()) < 0) {           // ҥץ
    perror("fork");                   // 顼ξϥ顼åɽ
    return 1;                         // 1ǰ۾ｪλ
  } else if (pid == 0) {              // ҥץξ
    write(1, "chlid process\n", 14);  // ҥץ¦å
    _exit(12);                        // λơ12ǻҥץλ
  }
  write(1, "parent process\n", 15);   // ƥץ¦å

  if (waitid(P_PID, (id_t)pid, &info, WEXITED) < 0) {  // ҥץԤ
    perror("waitid");                 // 顼ξϥåɽ
    return 1;                         // 1ǰ۾ｪλ
  }
  if (info.si_code == CLD_EXITED) {   // ¤ΥФǻҥץνλȽ
    printf(
      "pid = %d exited with status = %d\n",
      info.si_pid, info.si_status
    );                                // ҥץνλơɽ
  }
  return 0;                           // 0ｪλ
}
