#include <sys/stat.h>      // openfutimensΤɬפʥإåե
#include <fcntl.h>         // openΤɬפʥإåե
#include <unistd.h>        // readwriteΤɬפʥإåե
#include <stdio.h>         // perror()Τɬפʥإåե

int
main(int argc, char **argv)
{
  int fd_r, fd_w;          // ԡȥԡΥե뵭һ
  ssize_t n;               // ɤ߹ߥХȿѿ
  int err = 0;             // 顼Ͽѿ
  struct stat s_buf;       // եΥơstat¤
  struct timespec times[2];// ॹפꤹtimespec¤Τ
  char buf[4096];          // ǡѥХåե

  if (argc != 3) {         // ޥɰ2(argcǤ3)ʳξ
    fprintf(stderr, "Usage: %s source dest\n", argv[0]);
    return 1;              // Usage:ɽ1ǰ۾ｪλ
  }
                           // ԡΥեɤ߹Ѥǥץ
  if ((fd_r = open(argv[1], O_RDONLY)) < 0) {
    perror(argv[1]);       // 顼ξϥåɽ
    return 1;              // 1ǰ۾ｪλ
  }
                           // ԡΥեΥơ
  if (fstat(fd_r, &s_buf) < 0) {
    perror(argv[1]);       // 顼ξϥåɽ
    return 1;              // 1ǰ۾ｪλ
  }
                           // ԡΥե񤭹Ѥǥץ
  if ((fd_w = open(argv[2], O_WRONLY|O_CREAT|O_TRUNC, 0666)) < 0) {
    perror(argv[2]);       // 顼ξϥåɽ
    return 1;              // 1ǰ۾ｪλ
  }
                           // ԡեɤ߹EOFˤʤޤǥ롼
  while ((n = read(fd_r, buf, sizeof buf)) > 0) {
    if (write(fd_w, buf, n) < 0) {  // ɤ߹ǡ򥳥ԡ˽񤭹
      perror(argv[2]);     // 顼ξϥåɽ
      return 1;            // 1ǰ۾ｪλ
    }
  }
  if (n < 0) {             // readǥ顼ȯ
    perror(argv[1]);       // 顼åɽ
    return 1;              // 1ǰ۾ｪλ
  }

  times[0] = s_buf.st_atim;  // եΥ򥻥å
  times[1] = s_buf.st_mtim;  // եν򥻥å

  if (futimens(fd_w, times)) {  // ԡեΥॹפ
    perror(argv[2]);       // 顼ξϥåɽ
    err = 1;               // 顼Ͽƽ³
  }
                           // ԡեνͭԤȥ롼פ
  fchown(fd_w, s_buf.st_uid, s_buf.st_gid);  // 顼ϰտŪ̵뤹

                           // ԡեΥե⡼ɤ
  if (fchmod(fd_w, s_buf.st_mode) < 0) {
    perror(argv[2]);       // 顼ξϥåɽ
    err = 1;               // 顼Ͽƽ³
  }
  return err;              // 顼εϿͤȤƽλ
}
