#if defined(__sun__) && defined(__svr4__)   // Solarisξб
# include <unistd.h>       // SolarisioctlΤɬפʥإåե
# define BSD_COMP          // SolarisioctlΤɬפʥޥ
#endif

#include <sys/ioctl.h>     // ioctlΤɬפʥإåե

#include <sys/socket.h>    // socketΤɬפʥإåե
#include <net/if.h>        // struct ifconfʤɤΤɬפʥإåե
#include <netinet/in.h>    // sockaddr_in¤ΤΤɬפʥإåե
#include <arpa/inet.h>     // inet_ntoa()Τɬפʥإåե
#include <stdio.h>         // perror()printf()Τɬפʥإåե

int
main()
{
  struct ifconf ifc;       // SIOCGIFCONFǻѤ빽¤
  struct ifreq ifrbuf[16]; // 󥿥եȤξ
  struct ifreq *ifrp;      // ifrbuf[]ؤݥ
  int sfd;                 // åȤΥե뵭һ
  int adj = 0;             // FreeBSDξifrpΥɥ쥹׻

                           // INETɥᥤ󥽥åȤΥե뵭һҤ
  if ((sfd = socket(PF_INET, SOCK_DGRAM, 0)) < 0) {
    perror("socket");      // 顼ȯϥ顼åɽ
    return 1;              // 1ǰ۾ｪλ
  }

  ifc.ifc_req = ifrbuf;        // ifconf¤ΤνФifrbuf򥻥å
  ifc.ifc_len = sizeof ifrbuf; // ƱͤifrbufΥ򥻥å
  if (ioctl(sfd, SIOCGIFCONF, &ifc) < 0) { // 󥿥եι
    perror("ioctl(SIOCGIFCONF)");          // 顼ξϥåɽ
    return 1;                              // 1ǰ۾ｪλ
  }
                           // ͥåȥ󥿥եȤ˥롼
  for (
    ifrp = ifrbuf;         // ifrpifrbufƬ˽
                           // ifrbufɤ߹᤿ǡϰǥ롼
    ifrp < (struct ifreq *)&((char *)ifrbuf)[ifc.ifc_len];
    ifrp++                 // Υ󥿥ե˿ʤ
  ) {

#ifdef __FreeBSD__         // FreeBSDξб
                           // ifrpΥɥ쥹׻ͤ׻
    adj = ifrp->ifr_addr.sa_len - sizeof (struct sockaddr);
    if (adj < 0) {
      adj = 0;
    }
#endif
                           // ͥåȥ󥿥ե̾ɽ
    printf("%s:", ifrp->ifr_name);
                           // ͥåȥ󥿥եIPɥ쥹
    if (ioctl(sfd, SIOCGIFADDR, ifrp) < 0) {
      putchar('\n');       // IPɥ쥹̤ƾϲԤΤ߽
    } else {
                           // IPɥ쥹ɥåդ10ɽѴɽ
      printf(" %s\n",
        inet_ntoa(((struct sockaddr_in *)&ifrp->ifr_addr)->sin_addr)
      );
    }
                           // ifrpΥɥ쥹׻
    ifrp = (struct ifreq *)&((char *)ifrp)[adj];
  }                        // ʾforʸǥ롼

  return 0;                // 0ｪλ
}
