#include <sys/select.h>    // pselectΤɬפʥإåե

#include <signal.h>        // signalsigprocmaskΤɬפʥإåե
#include <errno.h>         // errnoΤɬפʥإåե
#include <stdio.h>         // perror()printf()Τɬפʥإåե

#if defined(__sun__) && defined(__svr4__)  // Solarisξб
# include <string.h>                    // FD_ZERO()Ѥmemset()
#endif

static int sigint_flag;    // SIGINT򼨤ե饰

static void
func_int()                 // SIGINTѤΥʥϥɥ
{
  sigint_flag = 1;         // SIGINTե饰򥻥å
}

int
main()
{
  int n;                   // ե뵭һҤθĿ
  fd_set readfds;          // ɤ߽Фƻѥե뵭һҤν
  struct timespec tv;      // ڤ
  sigset_t mask, unmask;   // ʥޥȡΥʥ

  sigemptyset(&mask);        // ʥޥ
  sigaddset(&mask, SIGINT);  // SIGINTޥޥξ֤
  if (sigprocmask(SIG_BLOCK, &mask, &unmask) < 0) {
    perror("sigprocmask");   // 顼ξϥ顼åɽ
    return 1;                // 1ǰ۾ｪλ
  }
  signal(SIGINT, func_int);  // SIGINTΥʥϥɥϿ

  FD_ZERO(&readfds);       // readfds
  FD_SET(0, &readfds);     // ե뵭һ0򥻥å
  FD_SET(4, &readfds);     // ե뵭һ4򥻥å

  tv.tv_sec = 2;           // ڤñ̤2ä˥å
  tv.tv_nsec = 500000000;  // ڤ̤0.5ä˥å

  sigint_flag = 0;         // SIGINTե饰򥯥ꥢ
                           // ǡޤSIGINTԤ
  n = pselect(5, &readfds, NULL, NULL, &tv, &unmask);

  if (n < 0) {             // 顼ޤϥʥξ
    if (errno == EINTR && sigint_flag) {  // SIGINTξ
      printf("\nreceive SIGINT\n");       // SIGINTλݤɽ
      return 0;                           // 0ｪλ
    }
    perror("pselect");     // 顼ξϥ顼åɽ
    return 1;              // 1ǰ۾ｪλ
  } else if (n == 0) {     // selectͤ0ξϻڤ
    printf("time out\n");  // ڤλݤɽ
  } else {
    if (FD_ISSET(0, &readfds)) {      // ե뵭һ0ؤå
      printf("input from fd = 0\n");  // λݤɽ
      // ǥե뵭һ0readԤ
    }
    if (FD_ISSET(4, &readfds)) {      // ե뵭һ4ؤå
      printf("input from fd = 4\n");  // λݤɽ
      // ǥե뵭һ4readԤ
    }
  }
  return 0;                // 0ｪλ
}
