#include <sys/socket.h>    // socketΤɬפʥإåե
#include <netinet/in.h>    // sockaddr_in¤ΤΤɬפʥإåե

#include <unistd.h>        // readwriteΤɬפʥإåե
#include <stdio.h>         // perror()Τɬפʥإåե
#include <string.h>        // memset()Τɬפʥإåե
#include <arpa/inet.h>     // inet_ntoa()Τɬפʥإåե

int
main()
{
  int sock_fd, ac_fd;      // socketacceptѤΥե뵭һ
  struct sockaddr_in sv_addr, cl_addr;   // ʬѤѤΥåȥɥ쥹
  socklen_t cl_len;        // cl_addrΥǼ
  int optval;              // åȥץ
  socklen_t optlen;        // optvalΥ
  ssize_t n;               // ǡΥХȿѿ
  char buf[4096];          // ǡѥХåե

                           // TCPåȤ
  if ((sock_fd = socket(PF_INET, SOCK_STREAM, 0)) < 0) {
    perror("socket");      // 顼ȯϥ顼åɽ
    return 1;              // 1ǰ۾ｪλ
  }

  optval = 1;              // ץͤ1ʿˤˤ
                           // SO_REUSEADDR1ꤷɥ쥹ƻѤ
  if (setsockopt(sock_fd, SOL_SOCKET, SO_REUSEADDR,
      &optval, sizeof optval) < 0) {
    perror("setsockopt");  // 顼ȯϥ顼åɽ
    return 1;              // 1ǰ۾ｪλ
  }

  optlen = sizeof optval;  // optlenoptvalΥ򥻥å
                           // SO_REUSEADDRͤ
  if (getsockopt(sock_fd, SOL_SOCKET, SO_REUSEADDR, &optval, &optlen) < 0) {
    perror("getsockopt");  // 顼ȯϥ顼åɽ
    return 1;              // 1ǰ۾ｪλ
  }
                           // SO_REUSEADDRͤɽ
  fprintf(stderr, "SO_REUSEADDR = %d\n", optval);

  memset(&sv_addr, 0, sizeof sv_addr);         // sv_addrƤ0˥ꥢ
  sv_addr.sin_family = AF_INET;                // INETɥᥤ
  sv_addr.sin_addr.s_addr = htonl(INADDR_ANY); // IPɥ쥹Ǥ
  sv_addr.sin_port = htons(12345);             // ݡֹ12345
                           // åȤ˥åȥɥ쥹Ƥ
  if (bind(sock_fd, (struct sockaddr *)&sv_addr, sizeof sv_addr) < 0) {
    perror("bind");        // 顼ȯϥ顼åɽ
    return 1;              // 1ǰ۾ｪλ
  }
                           // åȤlisten
  if (listen(sock_fd, SOMAXCONN) < 0) {
    perror("listen");      // 顼ȯϥ顼åɽ
    return 1;              // 1ǰ۾ｪλ
  }

  cl_len = sizeof cl_addr; // cl_lencl_addrΥ򥻥å
                           // 饤Ȥ³դ
  if ((ac_fd = accept(sock_fd, (struct sockaddr *)&cl_addr, &cl_len)) < 0) {
    perror("accept");      // 顼ȯϥ顼åɽ
    return 1;              // 1ǰ۾ｪλ
  }
                           // 饤ȤIPɥ쥹ȥݡֹɽ
  fprintf(stderr, "connect from addr = %s, port = %d\n",
    inet_ntoa(cl_addr.sin_addr),
    ntohs(cl_addr.sin_port)
  );
                           // 饤ȤΥǡʤ롼
  while ((n = read(ac_fd, buf, sizeof buf)) > 0) {
    write(ac_fd, buf, n);  // ǡ򤽤Τޤޥ饤Ȥ֤
    write(1, buf, n);      // ǡɸϤ˽
  }
  if (n < 0) {             // readǥ顼ȯ
    perror("read");        // 顼åɽ
    return 1;              // 1ǰ۾ｪλ
  }
                           // ̿Ǥ
  if (shutdown(ac_fd, SHUT_RDWR) < 0) {
    perror("shutdown");    // 顼ȯϥ顼åɽ
    return 1;              // 1ǰ۾ｪλ
  }
  return 0;                // 0ｪλ
}
