#include <sys/wait.h>      // wait3Τɬפʥإåե
#include <sys/time.h>      // wait3/gettimeofdayΤɬפʥإåե
#include <sys/resource.h>  // wait3Τɬפʥإåե
#include <unistd.h>        // forkexecvp()Τɬפʥإåե
#include <stdio.h>         // perror()Τɬפʥإåե

int
main(int argc, char **argv)
{
  int status;              // ҥץνλơѿ
  pid_t pid;               // ҥץΥץID
  struct rusage usage;     // ҥץΥ꥽rusage¤
  struct timeval tv_start, tv_end;  // ϻȽλϿ

                           // ޥɰʤUsage:ɽ
  if (argc <= 1) {
    fprintf(stderr, "Usage: %s command [arg...]\n", argv[0]);
    return 1;              // 1ǰ۾ｪλ
  }
                           // ߤλtv_start¸Ƥ
  if (gettimeofday(&tv_start, NULL) < 0) {
    perror("gettimeofday");  // 顼ξϥåɽ
    return 1;                // 1ǰ۾ｪλ
  }

                           // ҥץ
  if ((pid = fork()) < 0) {
    perror("fork");        // 顼ξϥåɽ
    return 1;              // 1ǰ۾ｪλ
  } else if (pid == 0) {        // ҥץξ
    execvp(argv[1], &argv[1]);  // ǻꤵ줿ޥɤ¹
    perror(argv[1]);            // ¹ԤǤʤäϥåɽ
    _exit(1);                   // 1ǻҥץλ
  }
                           // ҥץνλԤ꥽
  if (wait3(&status, 0, &usage) < 0) {
    perror("wait3");       // 顼ξϥåɽ
    return 1;              // 1ǰ۾ｪλ
  }
                           // ҥץλǤλtv_end˼
  if (gettimeofday(&tv_end, NULL) < 0) {
    perror("gettimeofday");  // 顼ξϥåɽ
    return 1;                // 1ǰ۾ｪλ
  }
                           // tv_endtv_secƷвᤷ»֤׻
  tv_end.tv_sec -= tv_start.tv_sec;
  if ((tv_end.tv_usec -= tv_start.tv_usec) < 0) { // 1̤η겼
    tv_end.tv_sec--;             // 겼ξ硢ñ̤1
    tv_end.tv_usec += 1000000;   // ޥñ̤1000000ޥäû
  }
                           // ҥץμ»֡桼֡ƥ֤
                           // ɸ२顼Ϥ˽
  fprintf(
    stderr,
    "real   = %ld.%06ld\n"
    "user   = %ld.%06ld\n"
    "system = %ld.%06ld\n",
    tv_end.tv_sec, tv_end.tv_usec,
    usage.ru_utime.tv_sec, usage.ru_utime.tv_usec,
    usage.ru_stime.tv_sec, usage.ru_stime.tv_usec
  );

  if (WIFEXITED(status)) {       // ҥץνλơ줿
    return WEXITSTATUS(status);  // νλơͤȤƽλ
  }
  return 1;                // ʳ1ǰ۾ｪλ
}
