#include <signal.h>           // sigprocmaskΤɬפʥإåե
#include <time.h>             // timer_settimeΤɬפʥإåե

#include <unistd.h>           // writeΤɬפʥإåե
#include <stdio.h>            // perror()printf()Τɬפʥإåե
#include <string.h>           // memset()Τɬפʥإåե

int
main()
{
  int signo;                  // sigwaitinfoͤΥʥֹ
  timer_t timerid;            // ID
  struct sigevent sigev;      // λưꤹsigevent¤
  struct itimerspec val;      // ޤͤ򥻥åȤitimerspec¤
  sigset_t set;               // sigprocmaskΤΥʥ뽸

  sigemptyset(&set);          // ʥ뽸˽
  sigaddset(&set, SIGALRM);   // ʥ뽸SIGALRMɲ
  sigaddset(&set, SIGINT);    // ʥ뽸SIGINTɲ
  if (sigprocmask(SIG_BLOCK, &set, NULL) < 0) {  // SIGALRMSIGINT֥å
    perror("sigprocmask");    // 顼ξϥåɽ
    return 1;                 // 1ǰ۾ｪλ
  }

  memset(&sigev, 0, sizeof sigev);        // sigev¤Τ0ǽ
  sigev.sigev_notify = SIGEV_SIGNAL;      // λϥʥȯ
  sigev.sigev_signo = SIGALRM;            // ʥֹSIGALRM
  sigev.sigev_value.sival_ptr = &timerid; // ʥϥɥϤ(̤)
                                          // »֥ޤ
  if (timer_create(CLOCK_REALTIME, &sigev, &timerid) < 0) {
    perror("timer_create");               // 顼ξϥåɽ
    return 1;                             // 1ǰ۾ｪλ
  }

  val.it_interval.tv_sec = 1;     // ޤδֳ֤1äˤ
  val.it_interval.tv_nsec = 0;    // 1̤ü0Ȥ
  val.it_value = val.it_interval; // ޤθͤ⥿ޤδֳ֤Ʊͤ
  if (timer_settime(timerid, 0, &val, NULL) < 0) {  // ޤ
    perror("timer_settime");      // 顼ξϥåɽ
    return 1;                     // 1ǰ۾ｪλ
  }

  if (timer_gettime(timerid, &val) < 0) {  // ޤθͤ
    perror("timer_gettime");      // 顼ξϥåɽ
    return 1;                     // 1ǰ۾ｪλ
  }
  printf(                         // ޤθͤɽ
    "it_interval = %ld.%09ld\n"
    "it_value    = %ld.%09ld\n",
    val.it_interval.tv_sec, val.it_interval.tv_nsec,
    val.it_value.tv_sec, val.it_value.tv_nsec
  );
                                  // SIGALRMޤSIGINTԤʤ롼
  while ((signo = sigwaitinfo(&set, NULL)) != SIGINT) {
    if (signo < 0) {              // 顼ξ
      perror("sigwaitinfo");      // 顼åɽ
      return 1;                   // 1ǰ۾ｪλ
    }
    if (signo == SIGALRM) {       // SIGALRMä
      write(1, ".", 1);           // ̤ˡ.פɽ
    }
  }
  write(1, "\nSIGINT\n", 8);      // SIGINTäϤλݤɽ

  if (timer_delete(timerid) < 0) {  // ޤ
    perror("timer_delete");         // 顼ξϥåɽ
    return 1;                       // 1ǰ۾ｪλ
  }

  return 0;                         // 0ｪλ
}
